java.util.zip

## Class Adler32

- java.lang.Object
- - java.util.zip.Adler32

- All Implemented Interfaces:
    Checksum

      public class Adler32
      extends Object
      implements Checksum

  Computes Adler32 checksum for a stream of data. An Adler32 checksum is not as reliable as a CRC32 checksum, but a lot faster to compute.

  The specification for Adler32 may be found in RFC 1950. (ZLIB Compressed Data Format Specification version 3.3)

  From that document:

  "ADLER32 (Adler-32 checksum) This contains a checksum value of the uncompressed data (excluding any dictionary data) computed according to Adler-32 algorithm. This algorithm is a 32-bit extension and improvement of the Fletcher algorithm, used in the ITU-T X.224 / ISO 8073 standard.

  Adler-32 is composed of two sums accumulated per byte: s1 is the sum of all bytes, s2 is the sum of all s1 values. Both sums are done modulo 65521. s1 is initialized to 1, s2 to zero. The Adler-32 checksum is stored as s2*65536 + s1 in most- significant-byte first (network) order."

  "8.2. The Adler-32 algorithm

  The Adler-32 algorithm is much faster than the CRC32 algorithm yet still provides an extremely low probability of undetected errors.

  The modulo on unsigned long accumulators can be delayed for 5552 bytes, so the modulo operation time is negligible. If the bytes are a, b, c, the second sum is 3a + 2b + c + 3, and so is position and order sensitive, unlike the first sum, which is just a checksum. That 65521 is prime is important to avoid a possible large class of two-byte errors that leave the check unchanged. (The Fletcher checksum uses 255, which is not prime and which also makes the Fletcher check insensitive to single byte changes 0 <-> 255.)

  The sum s1 is initialized to 1 instead of zero to make the length of the sequence part of s2, so that the length does not have to be checked separately. (Any sequence of zeroes has a Fletcher checksum of zero.)"

  Since:
    JDK 1.1
  Author:
    John Leuner, Per Bothner
  See Also:
    `InflaterInputStream`, `DeflaterOutputStream`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Adler32()` Creates a new instance of the `Adler32` class.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getValue()` Returns the Adler32 data checksum computed so far.
    `void` | `reset()` Resets the Adler32 checksum to the initial value.
    `void` | `update(byte[] buffer)` Updates the checksum with the bytes taken from the array.
    `void` | `update(byte[] buf, int off, int len)` Updates the checksum with the bytes taken from the array.
    `void` | `update(int bval)` Updates the checksum with the byte b.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Adler32

          public Adler32()

      Creates a new instance of the `Adler32` class. The checksum starts off with a value of 1.

  - ### Method Detail

    - #### reset

          public void reset()

      Resets the Adler32 checksum to the initial value.
      Specified by:
        `reset` in interface `Checksum`

    - #### update

          public void update(int bval)

      Updates the checksum with the byte b.
      Specified by:
        `update` in interface `Checksum`
      Parameters:
        `bval` - the data value to add. The high byte of the int is ignored.

    - #### update

          public void update(byte[] buffer)

      Updates the checksum with the bytes taken from the array.
      Parameters:
        `buffer` - an array of bytes

    - #### update

          public void update(byte[] buf,
                             int off,
                             int len)

      Updates the checksum with the bytes taken from the array.
      Specified by:
        `update` in interface `Checksum`
      Parameters:
        `buf` - an array of bytes
        `off` - the start of the data used for this update
        `len` - the number of bytes to use for this update

    - #### getValue

          public long getValue()

      Returns the Adler32 data checksum computed so far.
      Specified by:
        `getValue` in interface `Checksum`
      Returns:
        the current checksum value

Copyright © 2025 API Design. All Rights Reserved.